#pragma once

#include <Client/Scene.hpp>
#include <J3ML/LinearAlgebra.hpp>
#include <Core/Entity.hpp>
#include <Core/World.hpp>
#include "LocalWorld.hpp"
#include <JUI/Widgets/Scene.hpp>
#include <JUI/Widgets/Rect.hpp>
#include <JUI/Widgets/TextRect.hpp>
#include <Core/Item.hpp>

namespace CaveGame::Client {

    class LootTable
    {

    };




    class CraftingStation {};


    class Container
    {
    public:
        Container(int rows, int columns);

    protected:
    private:
    };

    class Storage : Container {};
    class PlayerHotbar : Container {};
    class PlayerPockets : Container {};
    class PlayerBackpack : Container {};
    class TradeMenu : Container {};

    class PlayerInventory : Container
    {

    };

    class ContainerGUI {

    };



    class HotbarGUI
    {
    public:
    protected:
    private:
    };

    using namespace JUI::UDimLiterals;
    using CaveGame::Core::Entity;
    class GameSession : public Scene {
    public:

        Core::TileID GetHotbarTile() const {
            return HotbarItems[active_hotbar_slot];
        }

        Core::TileID HotbarItems[10] = {
            Core::TileID::GRASS, Core::TileID::STONE, Core::TileID::WATER, Core::TileID::LAVA, Core::TileID::GREEN_MOSS, Core::TileID::SAND,
            Core::TileID::CLAY, Core::TileID::CLOUD, Core::TileID::COBBLESTONE, Core::TileID::ICE
        };
        GameSession() = default;
        GameSession(bool createNewWorld);

        void Update(float elapsed) override;

        void Draw() override;

        void Load() override;

        void Unload() override;
        void PassWindowSize(const J3ML::LinearAlgebra::Vector2 &size) override;
        void PassMouseInput(unsigned int, bool) override
        { }
        void PassMouseMovement(const J3ML::LinearAlgebra::Vector2 &pos) override
        { }
        void PassKeyInput(Key key, bool pressed) override;

        void SaveAndExit();

        void ConstructHUD();

        void UnloadHUD();

        Core::TileID GetTileUnderMouse();

        void HUDTick()
        {
            for (int i = 0; i < 10; i++)
            {
                hotbar_elements[i]->Size({44_px, 48_px});
                hotbar_elements[i]->CornerRounding(5);
                hotbar_elements[i]->SetBorderWidth(1.5f);
                hotbar_elements[i]->AnchorPoint({0.f, 0.8f});
            }

            Core::TileID active_item = HotbarItems[active_hotbar_slot];

            auto* data = GetByNumeric(active_item);

            item_label->SetContent(data->Name());

            hotbar_elements[active_hotbar_slot]->CornerRounding(8);
            hotbar_elements[active_hotbar_slot]->SetBorderWidth(1.5f);
            hotbar_elements[active_hotbar_slot]->Size({58_px, 56_px});
            hotbar_elements[active_hotbar_slot]->AnchorPoint({0.f, 0.75f});
        }

        LocalWorld* world;


        JUI::Scene* hud;
        JUI::Rect* hotbar_elements[10];
        JUI::TextRect* item_label;
    protected:
        int active_hotbar_slot = 0;

    private:

    };
}
