#pragma once
#include <Color4.hpp>
#include <J3ML/LinearAlgebra/Vector3.hpp>
#include <JGL/JGL.h>

namespace CaveGame::Client
{

    struct Particle
    {
        Vector3 position;
        Vector3 velocity;
        Color4 color;
        float size, angle, weight;
        float life; // Remaining life of the particle. If < 0: dead and unused.
    };

    const int MaxParticles = 100000;
    Particle ParticlesContainer[MaxParticles];


    int LastUsedParticle = 0;

    int FindUnusedParticle() {
        for (int i = LastUsedParticle; i < MaxParticles; i++) {
            if (ParticlesContainer[i].life < 0) {
                LastUsedParticle = i;
                return i;
            }
        }

        for (int i = 0; i < LastUsedParticle; i++) {
            if (ParticlesContainer[i].life < 0) {
                LastUsedParticle = i;
                return i;
            }
        }
        // All particles are taken, override the first one.
        return 0;
    }

    void StepParticles(float elapsed)
    {
        for (int i = 0; i < MaxParticles; i++) {
            Particle& p = ParticlesContainer[i];

            // Decrease life
            p.life -= elapsed;

            if (p.life <= 0.f){
                // Particles that just died will be put at the end of the buffer in SortParticles()
                //p.cameradistance = -1.f;
                continue;
            }


            // Simulate simple physics: gravity only, no collisions.
        }
    }

    void DrawParticles()
    {
        for (int i = 0; i < MaxParticles; i++)
        {
            Particle& p = ParticlesContainer[i];

            if (p.life <= 0)
                continue;

            //JGL::J2D::D
        }
    }
}
