///

#pragma once

#include <Client/Scene.hpp>
#include <JGL/JGL.h>
#include <array>

namespace CaveGame::Client
{
    /// The splash screen is responsible for displaying the Redacted Software Logo and then showing the loading bar.
    class Splash : public Scene
    {
    private:
        float splash_timer = 1.5f;
        float load_percent = 0.f;
        JGL::Texture* splash;

        std::array<JGL::RenderTarget*, 16> column_textures{};

        int column_width = 0;

        std::vector<float> scroll_offsets;
        std::vector<std::vector<char>> matrix;

        void ComputeMatrixGlyphTable();
        void ComputeMatrixTextureCache();

        void DrawMatrix();
        void DrawProgressBar();
    public:
        Splash();
        ~Splash() override;
        void Draw() override;
        void Update(float elapsed) override;
        void Load() override;
        void Unload() override;

        //void PassFont(JGL::Font passed);

        [[nodiscard]] bool SplashComplete() const;
    };
}