#include <Client/CreditsWindow.hpp>

JUI::TextRect* line_item(const std::string& content, int size, const Color4& color = Colors::White)
{
    auto* item = new JUI::TextRect();
    item->SetFont(JGL::Fonts::Jupiteroid);
    item->Size({0,4+size,1.f,0.f});
    item->SetTextSize(size);
    item->SetContent(content);
    item->AlignLeft();
    item->AlignTop();
    item->BGColor({0,0,0,0});
    item->SetTextColor(color);
    return item;
}

JUI::Window *CaveGame::Client::CreateCreditsWindowWidget(JUI::Widget *parent) {

    auto* credits_window = new JUI::Window(parent);
    credits_window->SetTitleFont(JGL::Fonts::Jupiteroid);
    credits_window->SetTitle("Credits");
    credits_window->MinSize({50, 50});
    credits_window->Size({300, 400, 0, 0});
    credits_window->Visible(false);

    auto* listing = new JUI::VerticalListLayout(credits_window->GetViewportInstance());
    listing->Margin(4_px);
    listing->Padding(5_px);

    int min_height = 0;
    for (auto[size, color, msg] : Credits)
    {
        listing->Add(line_item(msg, size, color));
        min_height += size;
    }

    /*
    line_item("CaveGame", 40, listing);
    line_item("A Redacted Software Product", 16, listing);
    line_item("Josh O'Leary", 24, listing);
    line_item("Design, Programming & Art", 16, listing);
    line_item("William Redacted", 24, listing);
    line_item("Redacted3D Game Technologies", 16, listing);
    line_item("Ash Tray", 24, listing);
    line_item("Art & Design", 16, listing);
    line_item("Evan Walter & Logan Caughlin", 24, listing);
    line_item("Music", 16, listing);
    line_item("Maxine Hayes", 24, listing);
    line_item("Systems Administration", 16, listing);
    line_item("Karl Darling", 24, listing);
    line_item("Financial Advisor", 16, listing);*/

    credits_window->Size({300, Math::Max(400, min_height), 0, 0});

    return credits_window;
}
