#pragma once

#include <Event.h>
#include <J3ML/LinearAlgebra.hpp>
#include <vector>
#include "Color4.hpp"
#include "Interfaces.hpp"
#include "Loggers.hpp"
#include "SimpleAABBSolver.hpp"

namespace CaveGame::Core {
    class StatusEffect {
    };


    class Lifeform {
    public:
        virtual int Health() const;
        virtual void SetHealth(int hp);
    };

    class DamageSource {

    };

    class Entity {
    public:

        Event<> Died;


        explicit Entity(const Vector2& spawnPoint);

        int Health() const;

        int MaxHealth() const;

        virtual void Draw() = 0;

        virtual void Update(float elapsed) = 0;

        Vector2 Position() const;

        Vector2 Size() const;

        virtual void CollisionTest(ITileMap* map, float step) {}
    protected:
        int health;
        int max_health;
        int entity_instance_id;
        float age;
        Vector2 position;
        Vector2 bounding_box;
        std::vector<StatusEffect> active_effects;
        Color4 color;
    private:

    };

    class PhysicalParticle {};


}
