
#pragma once

#include <Core/Data.hpp>

namespace CaveGame::Core
{
    using TileState = uint16_t;

    class ITileMap
    {
    public:
        [[nodiscard]] virtual TileID GetTile(int x, int y) const = 0;
        virtual void SetTile(int x, int y, TileID tile, bool flag_update = true) = 0;
        virtual void SwapTile(int source_x, int source_y, int dest_x, int dest_y, bool flag_update = true) = 0;
        [[nodiscard]] virtual bool GetTileUpdateFlag(int x, int y) const = 0;
        virtual void SetTileUpdateFlag(int x, int y, bool flag = true) = 0;
        //[[nodiscard]] virtual bool GetTileUpdateBufferFlag(int x, int y) const = 0;
        //virtual void SetTileUpdateBufferFlag(int x, int y, bool flag = true);
        [[nodiscard]] virtual TileState GetTileState(int x, int y) const = 0;
        virtual void SetTileState(int x, int y, TileState state) = 0;
        [[nodiscard]] bool IsNonSolidTile(int x, int y) const;
        [[nodiscard]] bool IsSolidTile(int x, int y) const;
        [[nodiscard]] bool HasAdjacentOrDiagonalAirBlock(int x, int y) const;
        [[nodiscard]] bool HasAdjacentAirBlock(int x, int y) const;
    };
}