#pragma once

#include <jlog/Logger.hpp>

namespace CaveGame::Logs
{

    using namespace jlog;
    using Logger = GenericLogger;

    extern Logger Info;
    extern Logger Debug;
    extern Logger Warning;
    extern Logger Error;
    extern Logger Fatal;

    extern Logger Client;
    extern Logger Server;
    extern Logger Generator;
    extern Logger Lighting;

    void SetAllEnableConsole(bool log_to_console);
    void SetAllEnableFile(bool log_to_file);
    void EnableAllToConsole();
    void EnableAllToFile();
    void DisableAllToConsole();
    void DisableAllToFile();
    void EnableAll();
    void DisableAll();
    void SetIncludeSourceLocationAll(bool inc_location);
    void SetIncludeTimestampAll(bool inc_timestamp);
    void EnableSourceLocationAll();
    void DisableSourceLocationAll();
    void EnableTimestampAll();
    void DisableTimestampAll();

}