#include <Core/Interfaces.hpp>

namespace CaveGame::Core
{
    bool ITileMap::IsNonSolidTile(int x, int y) const
    {
        TileID tile = GetTile(x, y);
        if (tile == TileID::AIR || tile == TileID::VINE || tile == TileID::WATER)
            return true;

        return false;
    }

    bool ITileMap::IsSolidTile(int x, int y) const
    {
        return !IsNonSolidTile(x, y);
    }

    bool ITileMap::HasAdjacentAirBlock(int x, int y) const
    {
        if (IsNonSolidTile(x+1, y) || IsNonSolidTile(x-1, y) || IsNonSolidTile(x, y+1) || IsNonSolidTile(x, y-1))
            return true;
        return false;
    }

    bool ITileMap::HasAdjacentOrDiagonalAirBlock(int x, int y) const
    {
        if (IsNonSolidTile(x+1, y) || IsNonSolidTile(x-1, y) || IsNonSolidTile(x, y+1) || IsNonSolidTile(x, y-1) ||
            IsNonSolidTile(x+1, y-1) || IsNonSolidTile(x-1, y+1) || IsNonSolidTile(x+1, y+1) || IsNonSolidTile(x-1, y-1))
            return true;
        return false;
    }
}
