#include <Core/PhysicsEntity.hpp>
#include <J3ML/LinearAlgebra/Vector2.hpp>

namespace CaveGame::Core
{
    PhysicsEntity::PhysicsEntity(const Vector2 &spawnPoint): Entity(spawnPoint) {
        next_position = spawnPoint;
    }

    Vector2 PhysicsEntity::Velocity() const { return velocity; }

    Vector2 PhysicsEntity::EstimatedNextPosition() const { return next_position; }

    void PhysicsEntity::Accelerate(const Vector2 &vector) {
        velocity += vector;
    }

    void PhysicsEntity::PhysicsUpdate(float elapsed) {
        next_position += velocity * elapsed;

        float friction = 3.45f;
        float gravity = 9.81f;
        float mass = 32.f;

        velocity *= (1 - (elapsed*friction));

        velocity.y += (elapsed*gravity*mass);

        position = next_position;
    }
}
